/**
 * EN: Computes the longest common substring of two strings.
 *
 * ZH: 计算两个字符串的最长公共子串。
 *
 * Usage:
 *
 * ```javascript
 * const ret = longestComSubstring('fish', 'finish');
 * console.log(ret);
 * ```
 *
 * Output:
 *
 * ```text
 * 3
 * ```
 *
 * @param {string} aStr String
 * @param {string} bStr String
 * @returns {number} Length
 * @category Calculate and Formula
 */
export declare function longestComSubstring(aStr: string, bStr: string): number;
/**
 * Alias of `longestComSubstring`.
 *
 * @hidden
 */
export declare function calLongestCommonSubstring(aStr: string, bStr: string): number;
/**
 * EN: Computes the longest common subsequence of two strings.
 *
 * ZH: 计算两个字符串的最长公共子序列。
 *
 * Usage:
 *
 * ```javascript
 * const ret = longestComSubsequence('fish', 'finish');
 * console.log(ret);
 * ```
 *
 * Output:
 *
 * ```text
 * 4
 * ```
 *
 * @param {string} aStr 字符串
 * @param {string} bStr 字符串
 * @returns {number} 长度
 * @category Calculate and Formula
 */
export declare function longestComSubsequence(aStr: string, bStr: string): number;
/**
 * Alias of `longestComSubsequence`.
 *
 * @hidden
 */
export declare function calLongestCommonSubsequence(aStr: string, bStr: string): number;
/**
 * EN: Hit probability (1% ~ 100%).
 *
 * ZH: 百分位概率。
 *
 * Usage:
 *
 * ```javascript
 * const ret = isHit(0.5); // 0.01 ~ 1 true/false
 * console.log(ret);
 * ```
 *
 * Output:
 *
 * ```text
 * true
 * ```
 *
 * Example: Test the precision.
 *
 * ```javascript
 * // Test
 * let trueCount = 0;
 * let falseCount = 0;
 * new Array(1000000).fill(0).forEach(() => {
 *   if (isHit(0.5)) {
 *     trueCount++;
 *   } else {
 *     falseCount++;
 *   }
 * });
 * console.log(trueCount, falseCount); // 499994 500006
 * ```
 *
 * @param {number} rate -- 0.1 ~ 1 => 1% ~ 100%
 * @returns {boolean} true 命中
 * @category Calculate and Formula
 */
export declare function isHit(rate: number): boolean;
/**
 * Alias of `isHit`.
 *
 * @hidden
 */
export declare function inRate(rate: number): boolean;
//# sourceMappingURL=calc.d.ts.map